<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Factories\HasFactory;
use Illuminate\Database\Eloquent\Model;
use App\Traits\LogsModelActivity;

class Branch extends Model
{
    /** @use HasFactory<\Database\Factories\ArtistFactory> */
    use HasFactory, LogsModelActivity;
    
    protected $fillable = [
        'name', 
        'external_ip',
        'enable',
    ];

    public function rooms() {
        return $this->hasMany(Room::class);
    }
    public function songs(){
        return $this->belongsToMany(Song::class)
                    ->withPivot('counts')
                    ->withTimestamps();
    }
    protected static function booted()
    {
        static::deleting(function (Branch $branch) {
            $branch->rooms()->delete();
        });
    }
}
